/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * DBFastClock.java
 *
 * Created on 2012-jan-01, 00:50:52
 */
package dbfastclock;

import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.FilenameFilter;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLClassLoader;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Locale;
import java.util.Properties;
import java.util.ResourceBundle;
import java.util.concurrent.Callable;
import java.util.concurrent.ScheduledThreadPoolExecutor;
import java.util.concurrent.TimeUnit;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.swing.border.Border;

/**
 *
 * @author Daniels laptop
 */
public class DBFastClock extends javax.swing.JFrame implements Runnable, MyPanelButtonListener, WindowListener
{
	static final int CLOCK_STYLE_ANALOG = 1;
	static final int CLOCK_STYLE_DIGITAL = 2;
	
	static final int COLOR_GREEN_FOREGROUND_BLACK_BACKGROUND = 0;
	static final int COLOR_WHITE_FOREGROUND_BLACK_BACKGROUND = 1;
	static final int COLOR_BLACK_FOREGROUND_WHITE_BACKGROUND = 2;
	
	private boolean programIsInitialized;
	private FileWriter debugFile;
	
    Properties prop = new Properties();
    MySignal mySignal = new MySignal();
    TCPClientComm tcpClientComm = new TCPClientComm(mySignal);
    int iClockLastDay = 0;
    int iClockLastHour = -1;
    int iClockLastMin = -1;
    int iClockLastSec = -1;
	int iRUTClockPulse = 0;
	Calendar fastClockTime = Calendar.getInstance();
	Calendar lastFastClockTime = Calendar.getInstance();
	Calendar lastTime = Calendar.getInstance();
	Boolean bProgramPauseClock = false;
	int clockStyle = CLOCK_STYLE_DIGITAL;
//	int clockStyle = CLOCK_STYLE_ANALOG;
	int colorSetting = COLOR_GREEN_FOREGROUND_BLACK_BACKGROUND;
	
	List<ResourceBundle> localizationResourceBundleList = new ArrayList<ResourceBundle>();
	ResourceBundle currentLocalizationResourceBundle = null;
	String currentLanguage = null;
	
	
	/** Creates new form DBFastClock */
	public DBFastClock()
	{
		initComponents();
		
		try
		{
			// Create file 
			debugFile = new FileWriter("debug.txt");
			mySignal.debug = new BufferedWriter(debugFile);
		}
		catch (IOException ex)
		{
//			Logger.getLogger(DBFastClock.class.getName()).log(Level.SEVERE, null, ex);
		}
		
        addWindowListener(this);
		
        readProperties();
        
        updateClock();

		mySignal.SetText(Boolean.parseBoolean(prop.getProperty("text_message_visible")), prop.getProperty("text_message_text"));
		
        mySignal.setIPaddressAndPort(	prop.getProperty("client_ip_address"),
										Integer.parseInt(prop.getProperty("client_tcp_port")));
	}

	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel_ClockPanel = new MyPanel(this);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("DBFastClock");

        jPanel_ClockPanel.setBackground(new java.awt.Color(0, 0, 0));
        jPanel_ClockPanel.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                jPanel_ClockPanelComponentResized(evt);
            }
        });

        javax.swing.GroupLayout jPanel_ClockPanelLayout = new javax.swing.GroupLayout(jPanel_ClockPanel);
        jPanel_ClockPanel.setLayout(jPanel_ClockPanelLayout);
        jPanel_ClockPanelLayout.setHorizontalGroup(
            jPanel_ClockPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 857, Short.MAX_VALUE)
        );
        jPanel_ClockPanelLayout.setVerticalGroup(
            jPanel_ClockPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 480, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel_ClockPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel_ClockPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

	private void jPanel_ClockPanelComponentResized(java.awt.event.ComponentEvent evt)//GEN-FIRST:event_jPanel_ClockPanelComponentResized
	{//GEN-HEADEREND:event_jPanel_ClockPanelComponentResized
		((MyPanel)jPanel_ClockPanel).componentResized();
	}//GEN-LAST:event_jPanel_ClockPanelComponentResized
	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[])
	{
		/* Set the Nimbus look and feel */
		//<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
		 * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
		 */
		try
		{
			for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels())
			{
				if ("Nimbus".equals(info.getName()))
				{
					javax.swing.UIManager.setLookAndFeel(info.getClassName());
					break;
				}
			}
		}
		catch (ClassNotFoundException ex)
		{
			java.util.logging.Logger.getLogger(DBFastClock.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		}
		catch (InstantiationException ex)
		{
			java.util.logging.Logger.getLogger(DBFastClock.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		}
		catch (IllegalAccessException ex)
		{
			java.util.logging.Logger.getLogger(DBFastClock.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		}
		catch (javax.swing.UnsupportedLookAndFeelException ex)
		{
			java.util.logging.Logger.getLogger(DBFastClock.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		}
		//</editor-fold>

		/* Create and display the form */
		java.awt.EventQueue.invokeLater(new Runnable()
		{

			public void run()
			{
				new DBFastClock().setVisible(true);
			}
		});
	}
	
	
    private void readProperties()
	{
        try
		{
            prop.load(new FileInputStream("properties.ini"));
			
			if (prop.getProperty("client_ip_address") == null)
				prop.setProperty("client_ip_address", "127.0.0.1");
            
			if (prop.getProperty("client_tcp_port") == null)
	            prop.setProperty("client_tcp_port", "2500");
        }
        catch(Exception ex) {
            prop.setProperty("client_ip_address", "127.0.0.1");
            prop.setProperty("client_tcp_port", "2500");
            prop.setProperty("color", "0");
            System.out.println(ex.getMessage());
        }
		
		
		colorSetting = Integer.parseInt(prop.getProperty("color_setting","0"));
		
		String clockStyleStr = prop.getProperty("clock_style", "analog");
		
		if (clockStyleStr.equals("analog"))
			clockStyle = DBFastClock.CLOCK_STYLE_ANALOG;
		else if (clockStyleStr.equals("digital"))
			clockStyle = DBFastClock.CLOCK_STYLE_DIGITAL;
		
		
		String path = "languages";
		File[] propertiesFiles = new File(path).listFiles(new FilenameFilter()
		{

			@Override
			public boolean accept(File dir, String name)
			{
				return name.endsWith(".properties");
			}
		});


		String desiredLanguage = prop.getProperty("language", "Svenska");

		Pattern pattern;
		Matcher matcher;
		String language;
		String country;
		ResourceBundle tempResourceBundle;

//		jComboBox_Language.removeAllItems();

		// \\A = början på input, \\d\\d? = en eller två siffror, : = kolon, \\z = slutet på input
		pattern = Pattern.compile("\\AMessagesBundle_(\\w\\w)_(\\w\\w)\\.properties\\z");

		if (propertiesFiles != null)
		{
			for (int i = 0; i < propertiesFiles.length; i++)
			{
				matcher = pattern.matcher(propertiesFiles[i].getName());

				if (matcher.matches())
				{
					language = matcher.group(1);
					country = matcher.group(2);

					ClassLoader loader = null;
					try
					{
						String absolutePath = propertiesFiles[i].getAbsolutePath();
						String filePath = absolutePath.substring(0, absolutePath.lastIndexOf(File.separator));
						URL[] urls =
						{
							new File(filePath).toURI().toURL()
						};
						loader = new URLClassLoader(urls);
						tempResourceBundle = ResourceBundle.getBundle("MessagesBundle", new Locale(language, country), loader);
						localizationResourceBundleList.add(tempResourceBundle);
						
						if (desiredLanguage.equals(tempResourceBundle.getString("language_name")))
						{
							currentLocalizationResourceBundle = tempResourceBundle;
							currentLanguage = tempResourceBundle.getString("language_name");
						}
					}
					catch (MalformedURLException ex)
					{
//						addInfoMessageLn(StringUtils.getStackTrace(ex));
					}
				}
				else
				{
					try
					{
//						jTextArea_Output.append("Filen " + propertiesFiles[i].toString() + " har ett felaktigt filnamn\n");
						mySignal.debug.write("Filen " + propertiesFiles[i].toString() + " har ett felaktigt filnamn\n");
					}
					catch (IOException ex)
					{
//						Logger.getLogger(DBFastClock.class.getName()).log(Level.SEVERE, null, ex);
					}
				}
			}

			if ( (currentLanguage == null) && (localizationResourceBundleList.size() > 0) )
			{
				currentLocalizationResourceBundle = localizationResourceBundleList.get(0);
				currentLanguage = currentLocalizationResourceBundle.getString("language_name");
			}
		}
		else
		{
			currentLanguage = null;
//			jTextArea_Output.append("No language files found\n");
		}
		
    }

	
    private void updateClock()
	{
        int iClockDay = -1;
        int iClockHour = -1;
        int iClockMin = -1;
        int iClockSec = -1;
        double dClockSpeed = -1;

		iClockHour = mySignal.getClockHour();
		iClockMin = mySignal.getClockMin();
		iClockSec = mySignal.getClockSec();
		dClockSpeed = mySignal.getClockSpeed();

		switch (colorSetting)
		{
			case COLOR_WHITE_FOREGROUND_BLACK_BACKGROUND:
				((MyPanel) jPanel_ClockPanel).SetColor(Color.WHITE, Color.BLACK, Color.WHITE);
				break;
			
			case COLOR_BLACK_FOREGROUND_WHITE_BACKGROUND:
				((MyPanel) jPanel_ClockPanel).SetColor(Color.BLACK, Color.WHITE, Color.BLACK);
				break;
			
			case COLOR_GREEN_FOREGROUND_BLACK_BACKGROUND:
			default:
				((MyPanel) jPanel_ClockPanel).SetColor(Color.GREEN, Color.BLACK, Color.RED);
		}
//		((MyPanel) jPanel_ClockPanel).SetColor(Color.GREEN, Color.BLACK);
		((MyPanel) jPanel_ClockPanel).SetText(mySignal.getTextVisible(), mySignal.getText());
        
        // Don't update clock if it hasn't changed since last
        if ((iClockDay != iClockLastDay) || (iClockHour != iClockLastHour) || (iClockMin != iClockLastMin) || (iClockSec != iClockLastSec))
        {
            ((MyPanel)jPanel_ClockPanel).SetClock(iClockDay,iClockHour,iClockMin,iClockSec,dClockSpeed);
        }
        
        iClockLastDay = iClockDay;
        iClockLastHour = iClockHour;
        iClockLastMin = iClockMin;
        iClockLastSec = iClockSec;
    }

    
	
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel_ClockPanel;
    // End of variables declaration//GEN-END:variables

	@Override
	public void run()
	{
		if (GetProgramPauseClock())
		{
			return;
		}

		updateClock();

		try
		{
			if (jPanel_ClockPanel != null)
				((MyPanel) jPanel_ClockPanel).paintNow();
		}
//		catch (Throwable e)
		catch (Exception e)
		{
			System.err.println("Error in DBFastClock.run: "+e);
//			e.printStackTrace();
//			System.err.println("Error in DBFastClock.run: "+e.getMessage());
		}
	}

	@Override
	public void ButtonSettingsPressed()
	{
		SetProgramPauseClock(true);
		
		SettingsDialog dialog = new SettingsDialog(this, prop);
		dialog.doneListener = new Callable() {
			@Override
			public Object call() throws Exception
			{
				mySignal.SetText(Boolean.parseBoolean(prop.getProperty("text_message_visible")), prop.getProperty("text_message_text"));
				SetProgramPauseClock(false);
				return null;
			}
		};
		
		dialog.setVisible(true);
	}
	
	
	public synchronized void SetProgramPauseClock(boolean bPause)
	{
		 bProgramPauseClock = bPause;
	}
	
	
	public synchronized boolean GetProgramPauseClock()
	{
		 return bProgramPauseClock;
	}
	
	
	@Override
	public void windowOpened(WindowEvent e)
	{
		setExtendedState(MAXIMIZED_BOTH);
	}

	@Override
	public void windowClosing(WindowEvent e)
	{
		// Save current clock value
		SettingsDialog dialog = new SettingsDialog(this, prop);
		dialog.writeProperties();
		
		try
		{
			mySignal.debug.close();
		}
		catch (IOException ex)
		{
//			Logger.getLogger(DBFastClock.class.getName()).log(Level.SEVERE, null, ex);
		}

		dispose();
		System.exit(0); //calling the method is a must
	}

	@Override
	public void windowClosed(WindowEvent e)
	{
//		System.out.println("windowClosed");
	}

	@Override
	public void windowIconified(WindowEvent e)
	{
//		throw new UnsupportedOperationException("Not supported yet.");
	}

	@Override
	public void windowDeiconified(WindowEvent e)
	{
//		throw new UnsupportedOperationException("Not supported yet.");
	}

	@Override
	public void windowActivated(WindowEvent e)
	{
		if (! programIsInitialized)
		{
			programIsInitialized = true;
			
			Thread tcpClientThread = new Thread(tcpClientComm);
			tcpClientThread.start();

			((MyPanel) jPanel_ClockPanel).buttonsListener = this;


			ScheduledThreadPoolExecutor executor = new ScheduledThreadPoolExecutor(3);
			executor.scheduleAtFixedRate(this, 0L, 10L, TimeUnit.MILLISECONDS);
		}
	}

	@Override
	public void windowDeactivated(WindowEvent e)
	{
//		throw new UnsupportedOperationException("Not supported yet.");
	}
	

	void localizeLabels(Container c)
	{
		Component[] components = c.getComponents();
		for (Component com : components)
		{
			if (com instanceof javax.swing.JLabel)
			{
				((javax.swing.JLabel) com).setText(getLocalizedName("label_", com.getName()));
			}
			else if (com instanceof javax.swing.JButton)
			{
				String name = com.getName();
				if (name != null)
					((javax.swing.JButton) com).setText(getLocalizedName("label_", name));
//				else
//					jTextArea_Output.append("Name is null\n");
			}
			else if (com instanceof javax.swing.JComboBox)
			{
				// Do nothing
			}
			else if (com instanceof javax.swing.JScrollBar)
			{
				// Do nothing
			}
			else if (com instanceof javax.swing.JCheckBox)
			{
				((javax.swing.JCheckBox) com).setText(getLocalizedName("label_", com.getName()));
			}
			else if (com instanceof javax.swing.JPanel)
			{
				Border border = ((javax.swing.JPanel) com).getBorder();
				
				if (border instanceof javax.swing.border.TitledBorder)
				{
					String name = com.getName();
					if (name != null)
						((javax.swing.border.TitledBorder) border).setTitle(getLocalizedName("label_", name));
				}
				
				if (com instanceof Container)
				{
					localizeLabels((Container) com);
				}
			}
			else
			{
				if (com instanceof Container)
				{
					localizeLabels((Container) com);
				}
			}
        }
	}
	
	
	public String getLocalizedName(String key_prefix, String key)
	{
		return getLocalizedName(key_prefix, key, null);
	}
	
	
	public String getLocalizedName(String key_prefix, String key, String parameter)
	{
		String value = key;
		
		if (currentLanguage == null)
		{
			if (parameter != null)
				return key + ": " + parameter;
			else
				return key;
		}
		
		if (key == null)
		{
			try
			{
				mySignal.debug.write("Software error in function getLocalizedName: The key is null. key_prefix: "+key_prefix+"\n");
//				jTextArea_Output.append(formatter.format(messageArguments));
			}
			catch (IOException ex1)
			{
//					Logger.getLogger(DBFastClock.class.getName()).log(Level.SEVERE, null, ex1);
			}
//			addInfoMessageLn("Software error in function getLocalizedName: The key is null. key_prefix: "+key_prefix);
			value = "<null>";
		}
		else if (! key.matches("no_translate"))		// Some labels should not be translated here, for example "am / pm"-label.
		{
			try
			{
				value = currentLocalizationResourceBundle.getString(key_prefix + key);
				
				if (parameter != null)
				{
					String key_template = currentLocalizationResourceBundle.getString(key_prefix + key)+"\n";
					
					Object[] messageArguments =
					{
						parameter
					};

					MessageFormat formatter = new MessageFormat("");
					formatter.setLocale(currentLocalizationResourceBundle.getLocale());
					formatter.applyPattern(value);
					value = formatter.format(messageArguments);
				}
			}
			catch (java.util.MissingResourceException ex)
			{
				String error_msg_template;
				String error_key = "";
				
				try
				{
					error_msg_template = currentLocalizationResourceBundle.getString("error_missing_error_msg_missing_localization_key")+"\n";
				}
				catch (java.util.MissingResourceException ex2)
				{
					error_key = ex2.getKey();
					error_msg_template	=	"The language file for \"{0}\" is missing the key \"{2}\"\n" +
											"The language file for \"{0}\" is missing the key \"{1}\"\n";
				}
				
				Object[] messageArguments =
				{
					currentLanguage,
					ex.getKey(),
					error_key
				};
				
				MessageFormat formatter = new MessageFormat("");
				formatter.setLocale(currentLocalizationResourceBundle.getLocale());
				formatter.applyPattern(error_msg_template);
				try
				{
					mySignal.debug.write(formatter.format(messageArguments)+"\n");
//					jTextArea_Output.append(formatter.format(messageArguments));
				}
				catch (IOException ex1)
				{
//					Logger.getLogger(DBFastClock.class.getName()).log(Level.SEVERE, null, ex1);
				}
			}
		}
		else
			value = "";
		
		return value;
	}
	
	
}
