/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * SettingsDialog.java
 *
 * Created on 2012-jan-01, 02:28:20
 */
package dbfastclock;

import java.awt.event.ItemEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Iterator;
import java.util.Properties;
import java.util.ResourceBundle;
import java.util.concurrent.Callable;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Daniels laptop
 */
public class SettingsDialog extends javax.swing.JDialog
{
	Callable doneListener;
	Properties prop;
	DBFastClock dbFastClock;
	
	
	/** Creates new form SettingsDialog */
	public SettingsDialog(	DBFastClock dbFastClock,
							Properties aProp)
	{
		super(dbFastClock, true);
		
		initComponents();
		
		this.dbFastClock = dbFastClock;
		prop = aProp;
		
/*
		jComboBox_Language.removeAllItems();
		jComboBox_Language.addItem("Svenska");
		jComboBox_Language.addItem("Norska");
		jComboBox_Language.addItem("Danska");
		jComboBox_Language.addItem("Engelska");
		jComboBox_Language.addItem("Tyska");
*/
		
		
		jComboBox_ColorSetting.removeAllItems();
		jComboBox_ColorSetting.addItem(dbFastClock.getLocalizedName("label_", "color_green_foreground_black_background"));
		jComboBox_ColorSetting.addItem(dbFastClock.getLocalizedName("label_", "color_white_foreground_black_background"));
		jComboBox_ColorSetting.addItem(dbFastClock.getLocalizedName("label_", "color_black_foreground_white_background"));
		jComboBox_ColorSetting.setSelectedIndex(Integer.parseInt(prop.getProperty("color_setting","0")));
		
//		jComboBox_ColorServerClient.addItem("Grön text, svart bakgrund");
//		jComboBox_ColorServerClient.addItem("Vit text, svart bakgrund");
//		jComboBox_ColorServerClient.addItem("Svart text, vit bakgrund");
//		jComboBox_ColorServerClient.addItem("Använd valda färger");
		
        jTextField_ClientIPaddress.setText(prop.getProperty("client_ip_address"));
        jTextField_ClientTCPport.setText(prop.getProperty("client_tcp_port"));
		
		
		jComboBox_ClockStyle.removeAllItems();
		jComboBox_ClockStyle.addItem(dbFastClock.getLocalizedName("label_", "clock_style_analog"));
		jComboBox_ClockStyle.addItem(dbFastClock.getLocalizedName("label_", "clock_style_digital"));

		if (dbFastClock.clockStyle == DBFastClock.CLOCK_STYLE_ANALOG)
			jComboBox_ClockStyle.setSelectedIndex(0);
		else if (dbFastClock.clockStyle == DBFastClock.CLOCK_STYLE_DIGITAL)
			jComboBox_ClockStyle.setSelectedIndex(1);
			
		ResourceBundle tempCurrentLocalizationResourceBundle = dbFastClock.currentLocalizationResourceBundle;
		
		jComboBox_Language.removeAllItems();
		
		Iterator iterator = dbFastClock.localizationResourceBundleList.iterator();
		
		while (iterator.hasNext())
		{
			ResourceBundle tempResourceBundle = (ResourceBundle) iterator.next();
			
			try
			{
				jComboBox_Language.addItem(tempResourceBundle.getString("language_name"));
				if (tempCurrentLocalizationResourceBundle == tempResourceBundle)
				{
					jComboBox_Language.setSelectedIndex(jComboBox_Language.getItemCount() - 1);
				}
			}
			catch (java.util.MissingResourceException ex)
			{
//				jTextArea_Output.append("Språkfilen " + propertiesFiles[i].getName() + " saknar nyckeln 'language_name'\n");
			}
		}
		
		dbFastClock.localizeLabels(this);
		
		pack();		// Se till att dialogen är tillräckligt stor efter "localizeLabels"
		
		
		addWindowListener(new WindowAdapter()
		{
			@Override
			public void windowClosed(WindowEvent e)
			{
//				System.out.println("jdialog window closed event received");
				
				try
				{
					if (doneListener != null)
					{
						doneListener.call();
					}
				}
				catch (Exception ex)
				{
					Logger.getLogger(SettingsDialog.class.getName()).log(Level.SEVERE, null, ex);
				}
			}

			@Override
			public void windowClosing(WindowEvent e)
			{
//				System.out.println("jdialog window closing event received");
			}
		});
	}

	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton_OK = new javax.swing.JButton();
        jButton_Cancel = new javax.swing.JButton();
        jPanel9 = new javax.swing.JPanel();
        jLabel12 = new javax.swing.JLabel();
        jTextField_ClientIPaddress = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        jTextField_ClientTCPport = new javax.swing.JTextField();
        jPanel7 = new javax.swing.JPanel();
        jComboBox_Language = new javax.swing.JComboBox();
        jLabel16 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jComboBox_ColorSetting = new javax.swing.JComboBox();
        jComboBox_ClockStyle = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jButton_OK.setText("OK");
        jButton_OK.setName("ok"); // NOI18N
        jButton_OK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_OKActionPerformed(evt);
            }
        });

        jButton_Cancel.setText("Cancel");
        jButton_Cancel.setName("cancel"); // NOI18N
        jButton_Cancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_CancelActionPerformed(evt);
            }
        });

        jPanel9.setBorder(javax.swing.BorderFactory.createTitledBorder("IP-adress och port"));
        jPanel9.setName("group_ip_address_and_port"); // NOI18N

        jLabel12.setText("IP-adress:");
        jLabel12.setName("ip_address"); // NOI18N

        jTextField_ClientIPaddress.setText("127.0.0.1");

        jLabel13.setText("TCP-port:");
        jLabel13.setName("tcp_port"); // NOI18N

        jTextField_ClientTCPport.setText("2500");

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel12)
                    .addComponent(jLabel13))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jTextField_ClientTCPport)
                    .addComponent(jTextField_ClientIPaddress, javax.swing.GroupLayout.DEFAULT_SIZE, 107, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel12)
                    .addComponent(jTextField_ClientIPaddress, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField_ClientTCPport, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel13))
                .addContainerGap(21, Short.MAX_VALUE))
        );

        jPanel7.setBorder(javax.swing.BorderFactory.createTitledBorder("Allmänt"));
        jPanel7.setName("group_common"); // NOI18N

        jComboBox_Language.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "aaa", "bbb", "ccc" }));
        jComboBox_Language.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jComboBox_LanguageItemStateChanged(evt);
            }
        });

        jLabel16.setText("Språk");
        jLabel16.setName("language"); // NOI18N

        jLabel9.setText("Val av färger:");
        jLabel9.setName("selection_of_colors"); // NOI18N

        jComboBox_ColorSetting.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jComboBox_ClockStyle.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Analog", "Digital" }));

        jLabel1.setText("Klocka:");
        jLabel1.setName("clock_style"); // NOI18N

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel16)
                    .addComponent(jLabel9)
                    .addComponent(jLabel1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jComboBox_ClockStyle, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jComboBox_ColorSetting, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jComboBox_Language, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel16)
                    .addComponent(jComboBox_Language, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel9)
                    .addComponent(jComboBox_ColorSetting, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jComboBox_ClockStyle, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel9, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton_OK, javax.swing.GroupLayout.Alignment.TRAILING))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton_Cancel))
                .addContainerGap(28, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(47, 47, 47)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton_OK)
                    .addComponent(jButton_Cancel))
                .addGap(75, 75, 75))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

	private void jButton_CancelActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jButton_CancelActionPerformed
	{//GEN-HEADEREND:event_jButton_CancelActionPerformed
/*
		try
		{
			if (doneListener != null)
				doneListener.call();
		}
		catch (Exception ex)
		{
			Logger.getLogger(SettingsDialog.class.getName()).log(Level.SEVERE, null, ex);
		}
*/
		dispose();
//		setVisible(false);
	}//GEN-LAST:event_jButton_CancelActionPerformed

	private void jButton_OKActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jButton_OKActionPerformed
	{//GEN-HEADEREND:event_jButton_OKActionPerformed
/*
		try
		{
			Double.parseDouble(jTextField_Speed.getText());
		}
		catch (java.lang.NumberFormatException e)
		{
			return;
		}
		
		prop.setProperty("clock", Integer.toString(jComboBox_ClockType.getSelectedIndex()));
		
		jComboBox_Day.setSelectedIndex(Integer.parseInt(prop.getProperty("clock_day")));
		prop.setProperty("clock_day", Integer.toString(jComboBox_Day.getSelectedIndex()));
		prop.setProperty("clock_hour", Integer.toString(Integer.parseInt(jTextField_Hour.getText())));
		prop.setProperty("clock_min", Integer.toString(Integer.parseInt(jTextField_Min.getText())));
		prop.setProperty("clock_sec", Integer.toString(Integer.parseInt(jTextField_Sec.getText())));
		
		try
		{
			prop.setProperty("clock_speed", Double.toString(Double.parseDouble(jTextField_Speed.getText())));
		}
		catch (java.lang.NumberFormatException e)
		{
			JOptionPane.showMessageDialog(null,"Hastighet är felaktigt. Ska vara ett tal med punkt för decimaler.");
		}
		
		System.out.println(jTextField_Min.getText()+", "+prop.getProperty("clock_min"));
*/		
		prop.setProperty("client_ip_address", jTextField_ClientIPaddress.getText());
		prop.setProperty("client_tcp_port", jTextField_ClientTCPport.getText());
		
//		jComboBox_Language.getSelectedIndex();
		
		prop.setProperty("color_setting",Integer.toString(jComboBox_ColorSetting.getSelectedIndex()));
		dbFastClock.colorSetting = jComboBox_ColorSetting.getSelectedIndex();
		
		if (jComboBox_ClockStyle.getSelectedIndex() == 0)
		{
			dbFastClock.clockStyle = DBFastClock.CLOCK_STYLE_ANALOG;
			prop.setProperty("clock_style", "analog");
		}
		else
		{
			dbFastClock.clockStyle = DBFastClock.CLOCK_STYLE_DIGITAL;
			prop.setProperty("clock_style", "digital");
		}
		
		writeProperties();
		
		dispose();
	}//GEN-LAST:event_jButton_OKActionPerformed

	private void jComboBox_LanguageItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_jComboBox_LanguageItemStateChanged
	{//GEN-HEADEREND:event_jComboBox_LanguageItemStateChanged
		try
		{
			// We get this event both for select and deselect item
			if (evt.getStateChange() == ItemEvent.SELECTED)
			{
				// Make sure the languages has been loaded
				if (!dbFastClock.localizationResourceBundleList.isEmpty())
				{
					dbFastClock.currentLocalizationResourceBundle = dbFastClock.localizationResourceBundleList.get(jComboBox_Language.getSelectedIndex());
					dbFastClock.currentLanguage = evt.getItem().toString();
					dbFastClock.localizeLabels(this);
					
					int selectedColorSetting = jComboBox_ColorSetting.getSelectedIndex();
					jComboBox_ColorSetting.removeAllItems();
					jComboBox_ColorSetting.addItem(dbFastClock.getLocalizedName("label_", "color_green_foreground_black_background"));
					jComboBox_ColorSetting.addItem(dbFastClock.getLocalizedName("label_", "color_white_foreground_black_background"));
					jComboBox_ColorSetting.addItem(dbFastClock.getLocalizedName("label_", "color_black_foreground_white_background"));
					jComboBox_ColorSetting.setSelectedIndex(selectedColorSetting);
					
					pack();		// Se till att dialogen är tillräckligt stor efter "localizeLabels"
//					updateStartPauseRUTClockButton();
				}

				prop.setProperty("language", evt.getItem().toString());
			}
		}
		catch (Throwable ex)
		{
//			addInfoMessageLn(StringUtils.getStackTrace(ex));
		}
	}//GEN-LAST:event_jComboBox_LanguageItemStateChanged

	
    public void writeProperties()
	{
        try
		{
//            if (jComboBoxSerialPort.getSelectedIndex() != -1)
//                prop.setProperty("com_port",jComboBoxSerialPort.getSelectedItem().toString());
//            else
//                prop.setProperty("com_port","");

            prop.store(new FileOutputStream("properties.ini"), "Settings");
        }
        catch(IOException ioe) {
            System.out.println(ioe.getMessage());
        }
    }


	
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton_Cancel;
    private javax.swing.JButton jButton_OK;
    private javax.swing.JComboBox jComboBox_ClockStyle;
    private javax.swing.JComboBox jComboBox_ColorSetting;
    private javax.swing.JComboBox jComboBox_Language;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JTextField jTextField_ClientIPaddress;
    private javax.swing.JTextField jTextField_ClientTCPport;
    // End of variables declaration//GEN-END:variables
}
