/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dbfastclock;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.Socket;
import java.net.UnknownHostException;

/**
 *
 * @author Daniels laptop
 */
public class TCPClientComm implements Runnable
{
    MySignal mySignal;
   
    public TCPClientComm(MySignal aMySignal)
	{
        mySignal = aMySignal;
    }
    
    public void run()
	{
		int iType = 0;
		boolean bIsActive = false;
		int iDay = -1;
		int iHour = -1;
		int iMin = -1;
		int iSec = -1;
		double dSpeed = 1.0;
		String sTextMessage = "";
		int iEqualSignIndex;
		String sParameter;
		String sValue;
		boolean bTextMessageVisible = false;
        
        while (true)
		{
			String sIPaddress = mySignal.getClientIPaddress();
			int iTCPport = mySignal.getClientTCPport();

			if (iTCPport != -1)
			{
				try
				{
					bTextMessageVisible = false;

					Socket socket = new Socket(sIPaddress, iTCPport);

					BufferedReader in = new BufferedReader(new InputStreamReader(socket.getInputStream(), "UTF-8"));
					String sLine;
					int iLineNr = 0;

					while ((sLine = in.readLine()) != null)
					{
						if (iLineNr == 0)	// Version 1 of the protocol
						{
							if (sLine.length() > 8)
							{
								mySignal.debug.write("Get data from server: " + sLine + "\r\n");

								iType = mySignal.getClockType();
								iDay = MySignal.WEEKDAY_NONE;
								iHour = Integer.parseInt(sLine.substring(2, 4).trim());
								iMin = Integer.parseInt(sLine.substring(5, 7).trim());
								iSec = -1;
								dSpeed = Integer.parseInt(sLine.substring(8, 10).trim());
							}
						}
						else	// Version 2 of the protocol
						{
							iEqualSignIndex = sLine.indexOf("=");

							if (iEqualSignIndex != -1)
							{
								sParameter = sLine.substring(0, iEqualSignIndex);
								sValue = sLine.substring(iEqualSignIndex + 1);

//									System.out.println("Parameter: "+sParameter+", value: "+sValue+"\n");

								if ("clocktype".equals(sParameter))
								{
//										System.out.println("Clocktype\n");
									if ("fastclock".equals(sValue))
									{
										iType = MySignal.CLOCK_TYPE__FAST_CLOCK;
									}
									else
									{
										if ("realclock".equals(sValue))
										{
											iType = MySignal.CLOCK_TYPE__REAL_CLOCK;
										}
										else
										{
											mySignal.debug.write("Error: Server send wrong clock type: " + sParameter + "\n");
										}
									}
								}
								else
								{
									if ("active".equals(sParameter))
									{
//										System.out.println("Active\n");
										if ("yes".equals(sValue))
										{
											bIsActive = true;
										}
										else
										{
											if ("no".equals(sValue))
											{
												bIsActive = false;
											}
											else
											{
												mySignal.debug.write("Error: Server send wrong \"active\": " + sParameter + "\n");
											}
										}
									}
									else
									{
										if ("day".equals(sParameter))
										{
											if ("none".equals(sValue))
											{
												iDay = MySignal.WEEKDAY_NONE;
											}
											else
											{
												if ("monday".equals(sValue))
												{
													iDay = MySignal.WEEKDAY_MONDAY;
												}
												else
												{
													if ("tuesday".equals(sValue))
													{
														iDay = MySignal.WEEKDAY_TUESDAY;
													}
													else
													{
														if ("wednesday".equals(sValue))
														{
															iDay = MySignal.WEEKDAY_WEDNESDAY;
														}
														else
														{
															if ("thursday".equals(sValue))
															{
																iDay = MySignal.WEEKDAY_THURSDAY;
															}
															else
															{
																if ("friday".equals(sValue))
																{
																	iDay = MySignal.WEEKDAY_FRIDAY;
																}
																else
																{
																	if ("saturday".equals(sValue))
																	{
																		iDay = MySignal.WEEKDAY_SATURDAY;
																	}
																	else
																	{
																		if ("sunday".equals(sValue))
																		{
																			iDay = MySignal.WEEKDAY_SUNDAY;
																		}
																		else
																		{
																			mySignal.debug.write("Error: Server send wrong weekday: " + sParameter + "\n");
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
										else
										{
											if ("clock".equals(sParameter))
											{
												String[] sValues = sValue.split(":");
												System.out.println("Clock: " + sValue);

												try
												{
													iHour = Integer.parseInt(sValues[0].trim());
													iMin = Integer.parseInt(sValues[1].trim());
													iSec = Integer.parseInt(sValues[2].trim());
												}
												catch (Exception ex)
												{
													mySignal.debug.write("Exception: " + ex.getMessage() + ". Parameter 'clock', value: '" + sValue + "''");
												}
											}
											else
											{
												if ("speed".equals(sParameter))
												{
													dSpeed = Double.parseDouble(sValue);
												}
												else
												{
													if ("text".equals(sParameter))
													{
														sTextMessage = sValue;
														sTextMessage = sTextMessage.replaceAll("\\\\n", "\n");

														// Visa text om textmeddelandet inte är tomt
														bTextMessageVisible = !sTextMessage.equals("");
													}
												}
											}
										}
									}
								}
							}
							else
							{
								if (!sLine.equals(""))
								{
									mySignal.debug.write("Error: Server send wrong string. No equal sign: " + sLine + "\n");
								}
							}
						}

						iLineNr++;
					}
					mySignal.setClock(iType, bIsActive, iDay, iHour, iMin, iSec, dSpeed);
					mySignal.SetText(bTextMessageVisible, sTextMessage);
				}
				catch (UnknownHostException ex)
				{
					try
					{
						mySignal.debug.write("Exception Unknown host: " + ex.getMessage() + "\r\n");
					}
					catch (IOException ex1)
					{
//							Logger.getLogger(TCPClientComm.class.getName()).log(Level.SEVERE, null, ex1);
					}
					mySignal.setClock(MySignal.CLOCK_TYPE__REAL_CLOCK, false, -1, -1, -1, -1, -1);
					System.out.println("Unknown host: " + sIPaddress);
				}
				catch (IOException ex)
				{
					try
					{
						mySignal.debug.write("Exception IO: " + ex.getMessage() + "\r\n");
					}
					catch (IOException ex1)
					{
//							Logger.getLogger(TCPClientComm.class.getName()).log(Level.SEVERE, null, ex1);
					}
					mySignal.setClock(-1, false, -1, -1, -1, -1, -1);
					System.out.println(ex.getMessage());
					System.out.println("No I/O");
				}
			}
			else
			{
				mySignal.setClock(MySignal.CLOCK_TYPE__REAL_CLOCK, false, -1, -1, -1, -1, -1);
			}
			
			try
			{
				Thread.currentThread().sleep(1000);
//				Thread.currentThread().sleep(500);
			}
			catch (InterruptedException ie)
			{
			}
        }

    }
    
}
